#property copyright "Scriptong"
#property link "http://autograf.dp.ua"

#property indicator_chart_window                   //     
#property indicator_buffers 7                      //    
#property indicator_color1 Blue                    //  1-  
#property indicator_color2 Red                     //  2-  
#property indicator_color3 Blue                    //  3-  
#property indicator_color4 Blue                    //  4-  
#property indicator_color5 Red                     //  5-  
#property indicator_color6 Red                     //  6-  
#property indicator_color7 Goldenrod               //  7-  


extern int    i_indType             = 0;           // 0 - CCI
                                                   // 1 - DeMarker
                                                   // 2 - RSI
                                                   // 3 - WPR
extern int    i_indPeriod           = 32;
extern int    i_indPrice            = PRICE_CLOSE; 
extern double i_overboughtLevel     = 100;
extern double i_oversoldLevel       = -100;
extern double i_percentageChange    = 0.1;
extern int    i_indBarsCount        = 50000;


//  
double g_limitUp[];                                //    ..
                                                   // ..   ..
                                                   // ..
double g_limitDn[];                                //    ..
                                                   // ..   ..
                                                   // ..
double g_maxOfUp[];                                //   ..
                                                   // ..  ..
                                                   // ..   ..
                                                   // ..
double g_minOfUp[];                                //   ..
                                                   // ..  ..
                                                   // ..   ..
                                                   // ..
double g_maxOfDn[];                                //   ..
                                                   // ..  ..
                                                   // ..   ..
                                                   // ..
double g_minOfDn[];                                //   ..
                                                   // ..  ..
                                                   // ..   ..
                                                   // ..
double g_enterPrice[];                             //   ,..
                                                   // ..  ..
                                                   // ..  ..
                                                   // ..
double g_indValue[];                               //                                                      
                                                   

//    
bool g_init,                                       //   ..
                                                   // ...  ..
                                                   // .. ..
                                                   // ..   ..
                                                   // ..
     g_activate;                                   //   ..
                                                   // ..

//                                                      
#define LEVEL_SUPPORT                  1           //    
#define LEVEL_RESISTANCE               2           //    


                                                   
#include <stderror.mqh>
//+-------------------------------------------------------------------------------------+
//| Custom indicator initialization function                                            |
//+-------------------------------------------------------------------------------------+
int init()
{
   g_activate = false;                             //   
   g_init = true;
   
   if (!IsParametersCorrect())                     //   ..
      return (-1);                                 // ..  - 
                                                   // .. 
                                                   
                                                   
   if (!BuffersBind())                             //    ..
      return (-1);                                 // ..  - ..
                                                   // ..  
                                                   
   g_activate = true;                                                   
   return(0);
}
//+-------------------------------------------------------------------------------------+
//| Custom indicator deinitialization function                                          |
//+-------------------------------------------------------------------------------------+
int deinit()
{
   return(0);
}
//+-------------------------------------------------------------------------------------+
//|                                                |
//+-------------------------------------------------------------------------------------+
bool BuffersBind()
{
   IndicatorBuffers(8);
   string name = WindowExpertName();
   if (
       !SetIndexBuffer(0, g_limitUp)      ||
       !SetIndexBuffer(1, g_limitDn)      || 
       !SetIndexBuffer(2, g_maxOfUp)      || 
       !SetIndexBuffer(3, g_minOfUp)      || 
       !SetIndexBuffer(4, g_maxOfDn)      || 
       !SetIndexBuffer(5, g_minOfDn)      || 
       !SetIndexBuffer(6, g_enterPrice)   || 
       !SetIndexBuffer(7, g_indValue)
      )
   {
      Alert(name, ":      .  ", 
            GetLastError());
      return (false);
   }

   for (int i = 0; i < 2; i++)                     //  
      SetIndexStyle(i, DRAW_HISTOGRAM);            // ..  

   for (i = 2; i < 7; i++)                         //  
      SetIndexStyle(i, DRAW_LINE);                 // ..  
      
   SetIndexLabel(0, " ");      
   SetIndexLabel(1, "  ");      
   SetIndexLabel(2, "  ");      
   SetIndexLabel(3, "  ");      
   SetIndexLabel(4, "  ");      
   SetIndexLabel(5, "  ");      
   SetIndexLabel(6, " ");      

   return (true);
}
//+-------------------------------------------------------------------------------------+
//|                          |
//+-------------------------------------------------------------------------------------+
bool IsParametersCorrect()
{
   string name = WindowExpertName();
   if (i_indType < 0 || i_indType > 3)
   {
      Alert("  3 - WPR");
      Alert("  2 - RSI");
      Alert("  1 - DeMarker");
      Alert("  0 - CCI");
      Alert(name, ":       0  3 :");
      return (false);
   }
   if (i_indPeriod < 1)
   {
      Alert(name, ":      . ",
                  "  .");
      return (false);
   }
   if (i_indPrice < PRICE_CLOSE || i_indPrice > PRICE_WEIGHTED)
   {
      Alert(name, ":       ", PRICE_CLOSE, "  ", 
                  PRICE_WEIGHTED, "  .  .");
      return (false);
   }
   if (i_overboughtLevel <= i_oversoldLevel)
   {
      Alert(name, ":       ",
                  " .  .");
      return (false);
   }
   if (i_percentageChange <= 0)
   {
      Alert(name, ":       .",
                  "  .");
      return (false);
   }
      
   return (true);
}
//+-------------------------------------------------------------------------------------+
//|                                                 |
//+-------------------------------------------------------------------------------------+
void BuffersInitializeAll()
{
   if (g_init)
   {
      g_init = false;
      return;
   }

   ArrayInitialize(g_limitUp, EMPTY_VALUE);
   ArrayInitialize(g_limitDn, EMPTY_VALUE);
   ArrayInitialize(g_maxOfUp, EMPTY_VALUE);
   ArrayInitialize(g_minOfUp, EMPTY_VALUE);
   ArrayInitialize(g_maxOfDn, EMPTY_VALUE);
   ArrayInitialize(g_minOfDn, EMPTY_VALUE);
   ArrayInitialize(g_enterPrice, EMPTY_VALUE);
   ArrayInitialize(g_indValue, EMPTY_VALUE);
}
//+-------------------------------------------------------------------------------------+
//|   ,                   |
//+-------------------------------------------------------------------------------------+
int GetRecalcIndex(int& total)
{
   int counted_bars = IndicatorCounted();
   total = Bars - i_indPeriod;                     //    ,..
                                                   // ..   ..
                                                   // .. 
   if (i_indBarsCount > 0 && i_indBarsCount < total)//     ..
      total = i_indBarsCount;                      // ..,    ..
                                                   // ..
   if (counted_bars == 0)                          // -   - 0. 
   {                                               // ..    ..
      BuffersInitializeAll();                      // ...  
      return(total);                               //    -  total
   }
   return (Bars - counted_bars - 1);               //    
}
//+-------------------------------------------------------------------------------------+
//|   pivotDirChange   Pivot           |
//+-------------------------------------------------------------------------------------+
void FillBuffer(int startIndex, int finishIndex, double value, double& buffer[])
{
   for (int i = startIndex; i >= finishIndex; i--)
      buffer[i] = value;
}
//+-------------------------------------------------------------------------------------+
//|                                    |
//+-------------------------------------------------------------------------------------+
double GetIndicatorValue(int index)
{
   switch (i_indType)
   {
      case 0: return (iCCI(NULL, 0, i_indPeriod, i_indPrice, index));
      case 1: return (iDeMarker(NULL, 0, i_indPeriod, index));
      case 2: return (iRSI(NULL, 0, i_indPeriod, i_indPrice, index));
      case 3: return (iWPR(NULL, 0, i_indPeriod, index));
   }
}
//+-------------------------------------------------------------------------------------+
//|   ,           |
//| ..                                                                            |
//+-------------------------------------------------------------------------------------+
int GetBarWithSpecIndValue(int fromIndex, int total, double level, int mode)
{
   for (int i = fromIndex; i < total; i++)
   {
      if ((mode == MODE_LOW && g_indValue[i] < level)
          ||
          (mode == MODE_HIGH && g_indValue[i] > level))
         return (i - 1);
   }
   
   return (i);
}
//+-------------------------------------------------------------------------------------+
//|              |
//| ...                                             |
//+-------------------------------------------------------------------------------------+
bool IsPriceExceeded(double price1, double price2)
{
   if (price1 == 0)
      return (false);
      
   double diff = price1 - price2;
   return (diff / price1 * 100 >= i_percentageChange);
}
//+-------------------------------------------------------------------------------------+
//|                         |
//+-------------------------------------------------------------------------------------+
void ShowSignal(double high, double low, int firstBar, int index, 
                double& limitHigh[], double& limitLow[], double& max[], double& min[])
{
   double open = Open[index];
   
   //      ?
   if (!IsPriceExceeded(high, open) || !IsPriceExceeded(open, low))
      return;

   //     
   limitLow[firstBar] = low;
   limitHigh[firstBar] = high;
   limitLow[index + 1] = low;
   limitHigh[index + 1] = high;
   FillBuffer(firstBar, index + 1, high, max);
   FillBuffer(firstBar, index + 1, low, min);
   FillBuffer(firstBar, index, open, g_enterPrice);
   
}
//+-------------------------------------------------------------------------------------+
//|                                               |
//+-------------------------------------------------------------------------------------+
void CalculateLevels(int index, int total)
{
   //      
   if (g_indValue[index + 1] < i_overboughtLevel &&
       g_indValue[index + 2] > i_overboughtLevel)
   {
      // ,       
      int firstLowBar = GetBarWithSpecIndValue(index + 3, total, 
                                                i_overboughtLevel, MODE_LOW);
      double low = Low[firstLowBar];
      
      //          
      double high = iHigh(NULL, 0, 
                          iHighest(NULL, 0, MODE_HIGH, firstLowBar - index, index + 1));
      
      ShowSignal(high, low, firstLowBar, index, 
                 g_limitDn, g_limitUp, g_maxOfDn, g_minOfDn);
      return;
   }
   
   //      
   if (g_indValue[index + 1] > i_oversoldLevel &&
       g_indValue[index + 2] < i_oversoldLevel)
   {
      // ,       
      int firstHighBar = GetBarWithSpecIndValue(index + 3, total, 
                                                i_oversoldLevel, MODE_HIGH);
      high = High[firstHighBar];

      //          
      low = iLow(NULL, 0, 
                 iLowest(NULL, 0, MODE_LOW, firstHighBar - index, index + 1));
      
      ShowSignal(high, low, firstHighBar, index, 
                 g_limitUp, g_limitDn, g_maxOfUp, g_minOfUp);
   }
}
//+-------------------------------------------------------------------------------------+
//|                                                           |
//+-------------------------------------------------------------------------------------+
void ProcessNewBars(int limit, int total)
{
   for (int i = limit; i >= 0; i--)                //   ..
      g_indValue[i] = GetIndicatorValue(i);        // ..   
                                                   // .. 
      
   for (i = limit; i >= 0; i--)                    //    ..
      CalculateLevels(i, total);                   // .. 
}
//+-------------------------------------------------------------------------------------+
//| Custom indicator iteration function                                                 |
//+-------------------------------------------------------------------------------------+
int start()
{
   if (!g_activate)
      return (0);
      
   int total;
   int limit = GetRecalcIndex(total);              //    
  
   ProcessNewBars(limit, total);                   //    
   
   return(0);
}

